# DO NOT EDIT! This file was auto-generated by crates/re_types_builder/src/codegen/python/mod.rs
# Based on "crates/re_types/definitions/rerun/blueprint/components/background_3d_kind.fbs".

# You can extend this class by creating a "Background3DKindExt" class in "background3d_kind_ext.py".

from __future__ import annotations

from typing import Sequence, Union

import pyarrow as pa

from ..._baseclasses import BaseBatch, BaseExtensionType, ComponentBatchMixin

__all__ = [
    "Background3DKind",
    "Background3DKindArrayLike",
    "Background3DKindBatch",
    "Background3DKindLike",
    "Background3DKindType",
]


from enum import Enum


class Background3DKind(Enum):
    """**Component**: The type of the background in 3D space views."""

    GradientDark = 1
    """Gradient depending on the direction of the view, dark theme."""

    GradientBright = 2
    """Gradient depending on the direction of the view, bright theme."""

    SolidColor = 3
    """Simple uniform color."""


Background3DKindLike = Union[Background3DKind, str]
Background3DKindArrayLike = Union[Background3DKindLike, Sequence[Background3DKindLike]]


class Background3DKindType(BaseExtensionType):
    _TYPE_NAME: str = "rerun.blueprint.components.Background3DKind"

    def __init__(self) -> None:
        pa.ExtensionType.__init__(
            self,
            pa.sparse_union(
                [
                    pa.field("_null_markers", pa.null(), nullable=True, metadata={}),
                    pa.field("GradientDark", pa.null(), nullable=True, metadata={}),
                    pa.field("GradientBright", pa.null(), nullable=True, metadata={}),
                    pa.field("SolidColor", pa.null(), nullable=True, metadata={}),
                ]
            ),
            self._TYPE_NAME,
        )


class Background3DKindBatch(BaseBatch[Background3DKindArrayLike], ComponentBatchMixin):
    _ARROW_TYPE = Background3DKindType()

    @staticmethod
    def _native_to_pa_array(data: Background3DKindArrayLike, data_type: pa.DataType) -> pa.Array:
        if isinstance(data, (Background3DKind, int, str)):
            data = [data]

        types: list[int] = []

        for value in data:
            if value is None:
                types.append(0)
            elif isinstance(value, Background3DKind):
                types.append(value.value)  # Actual enum value
            elif isinstance(value, int):
                types.append(value)  # By number
            elif isinstance(value, str):
                if hasattr(Background3DKind, value):
                    types.append(Background3DKind[value].value)  # fast path
                elif value.lower() == "gradientdark":
                    types.append(Background3DKind.GradientDark.value)
                elif value.lower() == "gradientbright":
                    types.append(Background3DKind.GradientBright.value)
                elif value.lower() == "solidcolor":
                    types.append(Background3DKind.SolidColor.value)
                else:
                    raise ValueError(f"Unknown Background3DKind kind: {value}")
            else:
                raise ValueError(f"Unknown Background3DKind kind: {value}")

        buffers = [
            None,
            pa.array(types, type=pa.int8()).buffers()[1],
        ]
        children = (1 + 3) * [pa.nulls(len(data))]

        return pa.UnionArray.from_buffers(
            type=data_type,
            length=len(data),
            buffers=buffers,
            children=children,
        )
