# DO NOT EDIT! This file was auto-generated by crates/re_types_builder/src/codegen/python/mod.rs
# Based on "crates/re_types/definitions/rerun/blueprint/datatypes/visible_time_range.fbs".

# You can extend this class by creating a "VisibleTimeRangeBoundaryKindExt" class in "visible_time_range_boundary_kind_ext.py".

from __future__ import annotations

from typing import Sequence, Union

import pyarrow as pa

from ..._baseclasses import BaseBatch, BaseExtensionType

__all__ = [
    "VisibleTimeRangeBoundaryKind",
    "VisibleTimeRangeBoundaryKindArrayLike",
    "VisibleTimeRangeBoundaryKindBatch",
    "VisibleTimeRangeBoundaryKindLike",
    "VisibleTimeRangeBoundaryKindType",
]


from enum import Enum


class VisibleTimeRangeBoundaryKind(Enum):
    """**Datatype**: Kind of boundary for visible history, see `VisibleTimeRangeBoundary`."""

    RelativeToTimeCursor = 1
    """Boundary is a value relative to the time cursor."""

    Absolute = 2
    """Boundary is an absolute value."""

    Infinite = 3
    """The boundary extends to infinity."""


VisibleTimeRangeBoundaryKindLike = Union[VisibleTimeRangeBoundaryKind, str]
VisibleTimeRangeBoundaryKindArrayLike = Union[
    VisibleTimeRangeBoundaryKindLike, Sequence[VisibleTimeRangeBoundaryKindLike]
]


class VisibleTimeRangeBoundaryKindType(BaseExtensionType):
    _TYPE_NAME: str = "rerun.blueprint.datatypes.VisibleTimeRangeBoundaryKind"

    def __init__(self) -> None:
        pa.ExtensionType.__init__(
            self,
            pa.sparse_union(
                [
                    pa.field("_null_markers", pa.null(), nullable=True, metadata={}),
                    pa.field("RelativeToTimeCursor", pa.null(), nullable=True, metadata={}),
                    pa.field("Absolute", pa.null(), nullable=True, metadata={}),
                    pa.field("Infinite", pa.null(), nullable=True, metadata={}),
                ]
            ),
            self._TYPE_NAME,
        )


class VisibleTimeRangeBoundaryKindBatch(BaseBatch[VisibleTimeRangeBoundaryKindArrayLike]):
    _ARROW_TYPE = VisibleTimeRangeBoundaryKindType()

    @staticmethod
    def _native_to_pa_array(data: VisibleTimeRangeBoundaryKindArrayLike, data_type: pa.DataType) -> pa.Array:
        if isinstance(data, (VisibleTimeRangeBoundaryKind, int, str)):
            data = [data]

        types: list[int] = []

        for value in data:
            if value is None:
                types.append(0)
            elif isinstance(value, VisibleTimeRangeBoundaryKind):
                types.append(value.value)  # Actual enum value
            elif isinstance(value, int):
                types.append(value)  # By number
            elif isinstance(value, str):
                if hasattr(VisibleTimeRangeBoundaryKind, value):
                    types.append(VisibleTimeRangeBoundaryKind[value].value)  # fast path
                elif value.lower() == "relativetotimecursor":
                    types.append(VisibleTimeRangeBoundaryKind.RelativeToTimeCursor.value)
                elif value.lower() == "absolute":
                    types.append(VisibleTimeRangeBoundaryKind.Absolute.value)
                elif value.lower() == "infinite":
                    types.append(VisibleTimeRangeBoundaryKind.Infinite.value)
                else:
                    raise ValueError(f"Unknown VisibleTimeRangeBoundaryKind kind: {value}")
            else:
                raise ValueError(f"Unknown VisibleTimeRangeBoundaryKind kind: {value}")

        buffers = [
            None,
            pa.array(types, type=pa.int8()).buffers()[1],
        ]
        children = (1 + 3) * [pa.nulls(len(data))]

        return pa.UnionArray.from_buffers(
            type=data_type,
            length=len(data),
            buffers=buffers,
            children=children,
        )
